C
C*** Example Driver 3
C
C     PROGRAM TWO(TSIN,TSTOUT,TAPE2=TSIN,TAPE3=TSTOUT)
C THIS PROGRAM WAS WRITTEN TO BE RUN IN SINGLE PRECISION ON A CDC7600.
      INTEGER IN, IOUT
      PARAMETER (IN=2, IOUT=6)
      DIMENSION XPLT(25),UPLT(2,2,404),SCRTCH(10)
      DIMENSION ERRMX(2),UEXACT(2),XBKPT(404)
      DIMENSION WORK(30000),IWORK(1000)
      CHARACTER *80 TITLE
      COMMON /GEAR0/ HUSED,NQUSED,NS,NF,NJ
      COMMON /ISTART/ IW1,IW2,IW3,IDUM(15)
      COMMON /PARAMS/ PI
C READ IN AND INITIALIZE PDECOL CALLING ARGUMENTS AND PARAMETERS.
      PI = 4. * ATAN(1.0)
      OPEN(IN,FILE='EG3.DAT',STATUS='OLD',FORM='FORMATTED')
      READ(IN,10) TITLE
   10 FORMAT(A)
      READ(IN,20) NPDE,MF,TOUT
   20 FORMAT(2I3,E10.3)
      WRITE(IOUT,10) TITLE
      WRITE(IOUT,30) NPDE,MF,TOUT
      TKEEP = TOUT
   30 FORMAT(//8H NPDE = ,I2,5X,5HMF = ,I2,
     *         5X,26H RESULTS ARE FOR TIME T = ,E10.3//
     *27H KORD  NINT       EPS      ,24HNSTEPS NRES  NJAC   NQ  ,
     *1X,30H   ERROR(1)       ERROR(2)     )
   40 READ(IN,50) KORD,NINT,EPS
   50 FORMAT(2I3,E10.3)
      IF(KORD.LE.0) STOP
      NPTS = NINT + 1
      NCC = 2
      TOUT = TKEEP
      IWORK(1) = 30000
      IWORK(2) = 1000
      T0 = 0.0
      DT = EPS * .5
      INDEX = 1
      NCPTS1 = KORD*NINT - NCC*(NINT-1) - 1
      DX = 1. / FLOAT(NINT)
      DO 60 I=1,NPTS
        XBKPT(I) = FLOAT(I-1)*DX
   60 CONTINUE
      CALL PDECOL(T0,TOUT,DT,XBKPT,EPS,NINT,KORD,NCC,NPDE,MF,INDEX,
     *            WORK,IWORK)
C CHECK FOR ERRORS AND THEN COMPUTE AN ESTIMATE FOR THE OVERALL
C MAXIMUM ERROR FOR EACH PDE COMPONENT. OUTPUT RESULTS.
      IF(INDEX.NE.0) WRITE(IOUT,70) INDEX
   70 FORMAT(7H INDEX=,I3)
      DO 80 I=1,NPDE
   80   ERRMX(I) = 0.
C WORK(IW3) TO WORK(IW3+NCPTS1) CONTAINS THE COLLOCATION POINTS.
      DO 100 J=1,NCPTS1
        DX = (WORK(IW3+J)-WORK(IW3+J-1))/24.
        DO 90 I=2,24
   90     XPLT(I) = FLOAT(I-1)*DX + WORK(IW3+J-1)
        XPLT(1) = WORK(IW3+J-1)
        XPLT(25) = WORK(IW3+J)
        DO 100 I=1,25
          CALL VALUES(XPLT(I),UPLT(1,1,I),SCRTCH,2,1,1,0,WORK)
          CALL TRUSOL(XPLT(I),TOUT,UEXACT)
          DO 100 K=1,NPDE
            UPLT(K,2,I) = ABS( UPLT(K,1,I) - UEXACT(K) )
            IF(UPLT(K,2,I) .GT. ERRMX(K)) ERRMX(K) = UPLT(K,2,I)
  100 CONTINUE
      WRITE(IOUT,110) KORD,NINT,EPS,NS,NF,NJ,NQUSED,(ERRMX(I),I=1,NPDE)
  110 FORMAT(I4,I6,1E14.3,1X,4I6,2E15.3)
      GO TO 40
      END
C SUBROUTINES FOR TWO PDE PROBLEM.
      SUBROUTINE F(T,X,U,UX,UXX,FVAL,NPDE)
      DIMENSION U(NPDE),UX(NPDE),UXX(NPDE),FVAL(NPDE)
      TEMP = EXP(-4.*X)
      FVAL(1) = (U(2)-1.0)*UXX(1) + UX(1)*UX(2) + (16.*X*T-2.*T
     *        - 16.*(U(2)-1.0))*(U(1)-1.0) + 10.*X*TEMP
      FVAL(2) = UXX(2) + UX(1) + 4.0*U(1) - 4.0 + X*X - 2.*T
     *        - 10.*T*TEMP
      RETURN
      END
      SUBROUTINE BNDRY(T,X,U,UX,DBDU,DBDUX,DZDT,NPDE)
      DIMENSION U(NPDE),UX(NPDE),DZDT(NPDE),DBDU(NPDE,NPDE),
     *          DBDUX(NPDE,NPDE)
      IF( X.NE. 0. ) GO TO 10
      DZDT(1) = 0.
      DZDT(2) = 0.
      DBDU(1,1) = 1.
      DBDU(1,2) = 0.
      DBDU(2,1) = 0.
      DBDU(2,2) = 1.
      DBDUX(1,1) = 0.
      DBDUX(1,2) = 0.
      DBDUX(2,1) = 0.
      DBDUX(2,2) = 0.
      RETURN
   10 CONTINUE
      DZDT(1) = 0.
      DZDT(2) = 0.
      DBDU(1,1) = 3.
      DBDU(1,2) = 0.
      DBDU(2,1) = -5.4598150033142E+01
      DBDU(2,2) = 0.
      DBDUX(1,1) = 1.
      DBDUX(1,2) = 0.
      DBDUX(2,1) = 0.
      DBDUX(2,2) = 5.
      RETURN
      END
      SUBROUTINE UINIT(X,U,NPDE)
      DIMENSION U(NPDE)
      CALL TRUSOL(X,0.,U)
      RETURN
      END
      SUBROUTINE DERIVF(T,X,U,UX,UXX,DFDU,DFDUX,DFDUXX,NPDE)
      DIMENSION U(NPDE),UX(NPDE),UXX(NPDE),DFDU(NPDE,NPDE)
      DIMENSION DFDUX(NPDE,NPDE),DFDUXX(NPDE,NPDE)
      DFDU(1,1) = 16.*X*T - 2.*T - 16.*(U(2)-1.0)
      DFDU(1,2) = UXX(1) - 16.*(U(1)-1.0)
      DFDU(2,1) = 4.
      DFDU(2,2) = 0.
      DFDUX(1,1) = UX(2)
      DFDUX(1,2) = UX(1)
      DFDUX(2,1) = 1.
      DFDUX(2,2) = 0.
      DFDUXX(1,1) = U(2) - 1.0
      DFDUXX(1,2) = 0.
      DFDUXX(2,1) = 0.
      DFDUXX(2,2) = 1.
      RETURN
      END
      SUBROUTINE TRUSOL(X,T,UEXACT)
      DIMENSION UEXACT(2)
      UEXACT(1) = 10.*X*T*EXP(-4.*X) + 1.0
      UEXACT(2) = T*X*X + 1.0
      RETURN
      END
